// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- GLOBAL VARIABLES -- //

// Overlay
var thumbstrips_button;
var thumbstrips_tray;
var thumbstrips_toolbar;
var thumbstrips_box;
var thumbstrips_scrollbox;
var thumbstrips_hidden;
var thumbstrips_splitter;
var thumbstrips_searchBox;

// Services, objects, preferences
var thumbstrips_prefs;
var thumbstrips_filmstrip;
var thumbstrips_emptyImage;

// Update intervals
var thumbstrips_pageUpdater;
var thumbstrips_timeUpdater;
var thumbstrips_resizeUpdater;
var thumbstrips_mouseScrollUpdater;
var thumbstrips_buttonScrollUpdater;

// Multi-use references
var thumbstrips_currentUrl;
var thumbstrips_deletedUrl;
var thumbstrips_currentNode;
var thumbstrips_currentHeight;
var thumbstrips_recording;
var thumbstrips_wasRecording;
var thumbstrips_printPreviewing;
var thumbstrips_ppInterrupted;
var thumbstrips_newInterrupted;
var thumbstrips_wasVisible;
var thumbstrips_mouseX;
var thumbstrips_mouseY;
var thumbstrips_mousePause;
var thumbstrips_statusBar;
var thumbstrips_scrollSpeed;
var thumbstrips_domainFiltering;
var thumbstrips_currentDomains;
var thumbstrips_currentSearchPatterns;

// Constants
var thumbstrips_textHeight = 50;
var thumbstrips_thumbnailClass = "thumbstrips_thumbnail";
var thumbstrips_containerClass = "thumbstrips_container";
var thumbstrips_currentClass = "thumbstrips_current";
var thumbstrips_paddingClass = "thumbstrips_padding";
var thumbstrips_titleClass = "thumbstrips_title";
var thumbstrips_timeClass = "thumbstrips_time";
var thumbstrips_popupClass = "thumbstrips_popup";
var thumbstrips_emptyThumbnailSignal = "-EMPTY THUMBNAIL-";

// Locale strings - recording
var thumbstrips_recordingStopLabel;
var thumbstrips_recordingStopTooltiptext;
var thumbstrips_recordingStartLabel;
var thumbstrips_recordingStartTooltiptext;

// Locale strings - searching/filtering
var thumbstrips_defaultSearchTerm;
var thumbstrips_contentButtonAllLabel;
var thumbstrips_contentButtonFilteredLabel;
var thumbstrips_contentAllLabel;

// Locale strings - scrolling
var thumbstrips_rewindingStatus;
var thumbstrips_fforwardingStatus;
var thumbstrips_pausedStatus;

// Locale strings - node details
var thumbstrips_deleteLabel;
var thumbstrips_deleteTooltiptext;
var thumbstrips_propsLabel;
var thumbstrips_propsTooltiptext;
var thumbstrips_nowLabel;

// Locale strings - save/load
var thumbstrips_alertSaved;
var thumbstrips_errorInvalidFileName;
var thumbstrips_errorUnableToSave;
var thumbstrips_errorInvalidFile;
var thumbstrips_errorUnableToLoad;

// Debugging variables
//var f_a;