// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- LOAD DIALOG -- //


var thumbstrips_loadDialog;
var thumbstrips_loadNameBox;
var thumbstrips_stringBundle;

var thumbstrips_xmlExtension = window.arguments[0];
var thumbstrips_fileList = window.arguments[1];
var thumbstrips_loadAcceptFunc = window.arguments[2];
var thumbstrips_loadDiskFunc = window.arguments[3];
var thumbstrips_loadCancelFunc = window.arguments[4];


function thumbstrips_onLoadDialogLoad() {
	thumbstrips_loadDialog = document.getElementById("thumbstrips_loadDialog");
	thumbstrips_loadNameBox = document.getElementById("thumbstrips_loadNameBox");
	thumbstrips_stringBundle = document.getElementById("thumbstrips_loadDialogStringBundle");
	
	var diskButton = thumbstrips_loadDialog.getButton("extra1");
	diskButton.setAttribute("oncommand", "thumbstrips_onLoadDialogDisk();");
	
	thumbstrips_onLoadDialogRedraw();
}


function thumbstrips_onLoadDialogRedraw() {
	// First, remove all children
	
	for (i = 0; i < thumbstrips_loadNameBox.childNodes.length; i = 0) {
		thumbstrips_loadNameBox.removeChild(thumbstrips_loadNameBox.childNodes[0]);
	}
	
	// Then add one child for each file
	
	for (var i = 0; i < thumbstrips_fileList.length; i++) {
		var li = document.createElement("listitem");
		var name = thumbstrips_fileList[i].leafName.slice(0, thumbstrips_fileList[i].leafName.lastIndexOf(thumbstrips_xmlExtension));
		var p = document.createElement("popup");
		var mi = document.createElement("menuitem");
		
		mi.setAttribute("label", thumbstrips_stringBundle.getString("deleteLabel"));
		mi.setAttribute("tooltiptext", thumbstrips_stringBundle.getString("deleteTooltiptext"));
		mi.setAttribute("oncommand", "thumbstrips_onLoadDialogDeleteFile(\"" + i + "\"); event.preventBubble();");
		
		p.setAttribute("id", "thumbstrips_loadDialogPopup" + i);
		p.appendChild(mi);
		thumbstrips_loadDialog.appendChild(p);
		
		li.setAttribute("label", name);
		li.setAttribute("context", p.id);
//		li.appendChild(p);
		
		thumbstrips_loadNameBox.appendChild(li);
//		thumbstrips_loadNameBox.appendChild(p);
	}
}


function thumbstrips_onLoadDialogDeleteFile(index) {
	var file = thumbstrips_fileList[index];
	thumbstrips_fileList.splice(index, 1);
	
//	thumbstrips_log("file = " + file + " | typeof = " + (typeof file));
//	file.QueryInterface(Components.interfaces.nsIFile);
	file.remove(false);

	thumbstrips_onLoadDialogRedraw();
}


function thumbstrips_onLoadDialogAccept() {
	var index = thumbstrips_loadNameBox.selectedIndex;
	thumbstrips_loadAcceptFunc(thumbstrips_fileList[index]);
}


function thumbstrips_onLoadDialogDisk() {
	
	var nsIFilePicker = Components.interfaces.nsIFilePicker;

	var fp = Components.classes["@mozilla.org/filepicker;1"]
				.createInstance(nsIFilePicker);
	
	fp.init(window, thumbstrips_stringBundle.getString("loadFilePickerName"), nsIFilePicker.modeOpen);
	
	fp.appendFilter(thumbstrips_stringBundle.getString("loadFilePickerFilter") + " (*" + thumbstrips_xmlExtension + ")", "*" + thumbstrips_xmlExtension)
	fp.appendFilters(nsIFilePicker.filterAll);

	var rv = fp.show();
	
	if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
		
		thumbstrips_loadDialog.cancelDialog();
		thumbstrips_loadDiskFunc(fp.file);
		
	}
	
}


function thumbstrips_onLoadDialogCancel() {
	thumbstrips_loadCancelFunc();
}