// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- NODE DETAILS -- //


function thumbstrips_goToNode(node, event) {
	var vc = node.getAttribute("vc");
	var origId = vc ? thumbstrips_getOriginalId(node.id, vc) : node.id;
	
	var wn = thumbstrips_filmstrip.getNodeById(origId);
	var ac = document.getElementById("appcontent");
	
	openUILink(wn.url, event, false, true);
	
	function getScrollPageListener(x, y) {
		
//		return function() {
//			content.scrollTo(x, y);
//			document.getElementById("appcontent").removeEventListener("load", getScrollPageListener(x, y), true);
//		}

		var foo = new Object();
		
		foo.handleEvent = function(event) {
			content.scrollTo(x, y);
			document.getElementById("appcontent").removeEventListener("load", foo, true);
		}
		
		return foo;

	}
	
	ac.addEventListener("load", getScrollPageListener(wn.scrollX, wn.scrollY), true);
}


function thumbstrips_handleNodeClick(node, eent) {
	var vc = node.getAttribute("vc");
	var origId = vc ? thumbstrips_getOriginalId(id, vc) : id;
	
	var wn = thumbstrips_filmstrip.getNodeById(origId);
	var url = wn.url;
	
	if (event.button === 0 && event.ctrlKey === false) {
		// left click only, open in current tab
	} else if (event.button === 1 || (event.button === 0 && event.ctrlKey === true)) {
		// middle click or ctrl + left click, open in new tab in background
	}
}


function thumbstrips_checkForMiddleClick(node, event) {
	// native code:
//	if (event.button === 1) {
//		eval(node.getAttribute("oncommand"));
//		closeMenus(event.target);
//	}

	if (event.button == 2) {
		return;
	}

	// modified code:
	var fn = new Function("event", node.getAttribute("oncommand"));
	fn.call(node, event); 
}



function thumbstrips_showNodeInfo(id) {
	// "Highlight" the container by setting the background
	
//	var container = document.getElementById(id);
//	
//	container.style.backgroundImage = "url(\"chrome://thumbstrips/skin/containerbg.png\")";
//	container.style.backgroundRepeat = "repeat";
	
	// Show the title of the page above the thumbnail
	
//	var titleLabel = document.getElementById(thumbstrips_titleClass + id);
//	var padding = document.getElementById(thumbstrips_paddingClass + id);
//	
//	padding.setAttribute("hidden", "true");
//	titleLabel.removeAttribute("hidden");
	
	// Show the URL of the page in the status bar
	
	var container = document.getElementById(id);
	var vc = container.getAttribute("vc");
	var origId = vc ? thumbstrips_getOriginalId(id, vc) : id;
	
	var node = thumbstrips_filmstrip.getNodeById(origId);
	var sb = document.getElementById("statusbar-display");
	
	thumbstrips_statusBar = sb.getAttribute("label");
	sb.setAttribute("label", node.url);
}

function thumbstrips_clearNodeInfo(id) {
	// Remove container "highlight" by clearing the background
	
//	var container = document.getElementById(id);
//	
//	container.style.backgroundImage = "none";
//	container.style.backgroundRepeat = "no-repeat";
	
	// Hide the title of the page above the thumbnail
	
//	var titleLabel = document.getElementById(thumbstrips_titleClass + id);
//	var padding = document.getElementById(thumbstrips_paddingClass + id);
//	
//	titleLabel.setAttribute("hidden", "true");
//	padding.removeAttribute("hidden");
	
	// Reset the status bar
	
	var sb = document.getElementById("statusbar-display");
	
	sb.setAttribute("label", thumbstrips_statusBar);
}