// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- OPTIONS DIALOG -- //


var thumbstrips_optionsDialog;

var thumbstrips_prefs = window.arguments[0];


function thumbstrips_onOptionsDialogLoad() {
	thumbstrips_propsDialog = document.getElementById("thumbstrips_optionsDialog");
	
	// set reset button
	
	reset = thumbstrips_propsDialog.getButton("extra1");
	reset.setAttribute("oncommand", "thumbstrips_onOptionsReset();");
	
	// set scrollbars
	
	thumbstrips_onOptionsReset();
}


function thumbstrips_onOptionsDialogAccept() {
	var page = document.getElementById("thumbstrips_optionsPageUpdateFreq");
	var mouse = document.getElementById("thumbstrips_optionsMouseUpdateFreq");
	
	var pageP = page.getAttribute("curpos");
	var mouseP = mouse.getAttribute("curpos");
	
	thumbstrips_prefs.setIntPref("time.page_update_frequency", thumbstrips_pagePercentToFreq(pageP));
	thumbstrips_prefs.setIntPref("time.mouse_update_frequency", thumbstrips_mousePercentToFreq(mouseP));
}

function thumbstrips_onOptionsReset() {
	var page = document.getElementById("thumbstrips_optionsPageUpdateFreq");
	var mouse = document.getElementById("thumbstrips_optionsMouseUpdateFreq");
	
	var pageF = thumbstrips_prefs.getIntPref("time.page_update_frequency");
	var mouseF = thumbstrips_prefs.getIntPref("time.mouse_update_frequency");
	
	page.setAttribute("curpos", thumbstrips_pageFreqToPercent(pageF));
	mouse.setAttribute("curpos", thumbstrips_mouseFreqToPercent(mouseF));
}

function thumbstrips_onOptionsDialogCancel() {
	// nothing
}


// convert a prefs number (e.g. 20 milliseconds) to percentage (for scrollbar)
// yes, I realize I am calling it frequency when it's actually period!
// because of this, the return value is "reversed"
// e.g. if the min freq is 10 and the max is 100, and x = 28,
//      this function returns 100% - (28 - 10) / (100 - 10) = 18 / 90 = 80%

function thumbstrips_pageFreqToPercent(x) {
	var min = thumbstrips_prefs.getIntPref("options.page_min_value");
	var max = thumbstrips_prefs.getIntPref("options.page_max_value");
	
	return 100 - ( 100 * (x - min) / (max - min) );
}

function thumbstrips_mouseFreqToPercent(x) {
	var min = thumbstrips_prefs.getIntPref("options.mouse_min_value");
	var max = thumbstrips_prefs.getIntPref("options.mouse_max_value");
	
	return 100 - ( 100 * (x - min) / (max - min) );
}

// convert a percentage (for scrollbar) to prefs number (e.g. 20 milliseconds)
// e.g. if the min freq is 10 and the max is 100, and x = 80,
//      this function returns 

function thumbstrips_pagePercentToFreq(p) {
	var min = thumbstrips_prefs.getIntPref("options.page_min_value");
	var max = thumbstrips_prefs.getIntPref("options.page_max_value");
	
	return max - ( p * (max - min) / 100 );
}

function thumbstrips_mousePercentToFreq(p) {
	var min = thumbstrips_prefs.getIntPref("options.mouse_min_value");
	var max = thumbstrips_prefs.getIntPref("options.mouse_max_value");
	
	return max - ( p * (max - min) / 100 );
}