// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- PROPERTIES DIALOG -- //


var thumbstrips_propsDialog;

var thumbstrips_propsNode = window.arguments[0];


function thumbstrips_onPropsDialogLoad() {
	thumbstrips_propsDialog = document.getElementById("thumbstrips_propsDialog");
	
	// fill in the values
	
	var node = thumbstrips_propsNode;
	
	var title = document.getElementById("thumbstrips_propsTitle");
	var url = document.getElementById("thumbstrips_propsUrl");
	var firstVisit1 = document.getElementById("thumbstrips_propsFirstVisit1");
	var firstVisit2 = document.getElementById("thumbstrips_propsFirstVisit2");
	var lastVisit1 = document.getElementById("thumbstrips_propsLastVisit1");
	var lastVisit2 = document.getElementById("thumbstrips_propsLastVisit2");
	var visitCount = document.getElementById("thumbstrips_propsVisitCount");
	var visitTime = document.getElementById("thumbstrips_propsVisitTime");
	var pageText = document.getElementById("thumbstrips_propsPageText");
	
	title.setAttribute("value", node.title);
	url.setAttribute("value", node.url);
	
	var fv = node.getVisitList()[0];
	firstVisit1.setAttribute("value", fv.toLocaleString());
	firstVisit2.setAttribute("value", "(" + thumbstrips_getTimeAgo(fv) + ")");
	
	var lv = node.getVisitList()[node.getVisitCount() - 1];
	lastVisit1.setAttribute("value", lv.toLocaleString());
	lastVisit2.setAttribute("value", "(" + thumbstrips_getTimeAgo(lv) + ")");
	
	visitCount.setAttribute("value", node.getVisitCount());
	visitTime.setAttribute("value", thumbstrips_getTimeLength(node.getVisitTimeInMilliseconds()));
	
	pageText.setAttribute("value", thumbstrips_trim(node.pageText));
	pageText.setSelectionRange(0, 0);
	
}


function thumbstrips_onPropsDialogAccept() {
	// nothing
}