// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- SEARCH -- //

function thumbstrips_clearSearch(noUpdate) {
	delete thumbstrips_currentSearchPatterns;
	thumbstrips_currentSearchPatterns = new Array();
	
	//thumbstrips_changeSearchTextColor(thumbstrips_searchBox, 'grey');
	document.getElementById('thumbstrips_searchBox').setAttribute('style','color: grey');
	
//	thumbstrips_searchBox.setAttribute("value", ""); // DOES NOT WORK!
	
	thumbstrips_searchBox.value = "";
	thumbstrips_blurSearch(thumbstrips_searchBox);
	
	if (noUpdate) {
		return;
	}
	
	thumbstrips_updateSearch("");
	thumbstrips_tray.focus();
}

function thumbstrips_blurSearch(textbox) {
	if (textbox.value === "") {
		textbox.value = thumbstrips_defaultSearchTerm;
		//textbox.style.color = "grey";
		//thumbstrips_changeSearchTextColor(textbox, 'grey');
		document.getElementById('thumbstrips_searchBox').setAttribute('style','color: grey');
	}
}

function thumbstrips_focusSearch(textbox) {
	if (textbox.value === thumbstrips_defaultSearchTerm) {
		//textbox.style.color = "black";
		document.getElementById('thumbstrips_searchBox').setAttribute('style','color: black');
		textbox.value = "";	
	} 
	else {
		textbox.select();
	}
}

function thumbstrips_updateSearch(value) {
	// split search string into multiple words, and do an AND search
	
	var text = value.replace(/[\\\^\$\*\+\?\.\(\)\:\=\|\{\}\[\]\,]/g, "\\$&");
	var textArray = text.split(' ');
	
	thumbstrips_currentSearchPatterns = new Array(textArray.length);
	
	for (var i = 0; i < textArray.length; i++) {
		// regexp is tricky... never know when we might get an error
		try {
			thumbstrips_currentSearchPatterns[i] = new RegExp(textArray[i], "i"); // "i" means ignore case
		} catch (e) {
			thumbstrips_currentSearchPatterns[i] = new RegExp("", "i");
		}
	}
	
	thumbstrips_searchAllNodes();
}


function thumbstrips_searchOneNode(displayNode) {
//	var displayNode = document.getElementById(id);
//	var filmstripNode = thumbstrips_filmstrip.getNodeById(id);
//	var filmstripNode = thumbstrips_filmstrip.getNodeById(displayNode.id);

	var vc = displayNode.getAttribute("vc");
	var id = vc ? thumbstrips_getOriginalId(displayNode.id, vc) : displayNode.id;
	
	var filmstripNode = thumbstrips_filmstrip.getNodeById(id);
	
	// search the title, URL and pagetext simultaneously
	var string = filmstripNode.title + filmstripNode.url + filmstripNode.pageText;
	var match = true;
	
	// if text is "" or search is positive on EVERY word, show it, else hide it
	for (var i = 0; i < thumbstrips_currentSearchPatterns.length; i++) {
		if (thumbstrips_currentSearchPatterns[i] === "" || string.search(thumbstrips_currentSearchPatterns[i]) >= 0) {
			match = true;
		} else {
			match = false;
			break;
		}
	}
	
	if (match === true) {
		thumbstrips_updateHiddenStatus(displayNode, "search", false);
	} else {
		thumbstrips_updateHiddenStatus(displayNode, "search", true);
	}
}


function thumbstrips_searchAllNodes() {
//	var text = thumbstrips_currentSearch;
//	var textArray = text.split(' ');
//	
//	var patterns = new Array(textArray.length);
//	var i, j;
//	
//	for (i = 0; i < textArray.length; i++) {
//		patterns[i] = new RegExp(textArray[i], "i"); // "i" means ignore case
//	}

	var nodes = thumbstrips_box.childNodes;
				
	for (var i = 0; i < nodes.length; i++) {
//		var displayNode = nodes[i];
//		var filmstripNode = thumbstrips_filmstrip.getNodeById(displayNode.id);
//		
//		// search both title and URL simultaneously
//		var string = filmstripNode.title + filmstripNode.uri.spec;
//		var match = true;
//		
//		for (var j = 0; j < patterns.length; j++) {
//			if (patterns[j] === "" || string.search(patterns[j]) >= 0) {
//				match = true;
//			} else {
//				match = false;
//				break;
//			}
//		}
//		
//		if (match === true) {
////			displayNode.removeAttribute("hidden");
//			thumbstrips_updateHiddenStatus(displayNode, "search", false);
//		} else {
////			displayNode.setAttribute("hidden", "true");
//			thumbstrips_updateHiddenStatus(displayNode, "search", true);
//		}

//		thumbstrips_searchOneNode(nodes[i].id);
		thumbstrips_searchOneNode(nodes[i]);
	}
}